#include <iostream>
// Hlavickovy soubor stdlib.h obsahuje funkce standardni knihovny C.
// Zde je vlozen kvuli funkcim pro dynamickou alokaci pameti malloc a free.
#include <stdlib.h>

using namespace std;

char *fce1(){
    int a;
    char p[10]; // staticky alokovane pole
    
    // nejake operace
    
    return p;
} // funkce konci, a i p zanikaji

char *fce2(){

    char *p; // ukazatel p bude ukazovat na zacatek dynam. alokovaneho pole
    
    p = new char[10]; // dynamicka alokace
    // p = (char *) malloc(10); // alokace v cecku (alokuje 10B)
    int *integer = (int *) malloc(10 * sizeof(int)); //alokace pro 10 integeru  
    free(integer); // uklid
    
    return p;
} // p zanikne, ale adresu alokovane pameti jsme si vratili, takze je to v poradku

// Zavolani funkce zabere 1MB operacni pameti, ktery zustane alokovan, dokud nebude
// chod aplikace ukoncen.
void memoryLeak(){
    char *i = new char [1024*1024*1024]; // alokovali jsme pamet, kterou nelze uvolnit
}

// Funkce alokuje pamet o velikosti 10B a vrati ukazatel na zacatek alokovane pameti.
char * memoryAllock(){
    char *i = new char [10];
    return i;
}

// Nasledujici 3 funkce demonstruji potrebu ukazatelu a referenci a zaroven ukazuji
// rozdily, ktere mezi nimi jsou.
// Funkce f1 je naprosto zbytecna, neprovede zadnou zmenu.
void f1(int i){
    i = 3; // 3 jsme do ulozili do lokalni promenne i
}

// Funkce f2 a f3 meni hodnotu v promenne typu integer, ktera je funkci predana jako
// parametr.
void f2(int *i){
    *i = 3; // integer i vlozeny jako parametr funkci prepiseme hodnotou 3
}

void f3(int &i){
    i = 3; // integer i vlozeny jako parametr funkci prepiseme hodnotou 3
}

int main(){

    char *pointerChar = fce1(); // Chyba, pamet na kterou to ukazuje je neplatna,
								// neni definovano dalsi chovani. Pri prekladu
								// tohoto zdrojaku na to prekladac upozornuje
								// (Warning), ale kod prelozi!
    pointerChar[0] = 'a';		// Tohle bude ve vetsine pripadu fungovat, ale
								// se na to spolehnout!!!
    cout << *pointerChar << endl;

    char *pChar = fce2(); // pChar ukazuje na pamet alokovanou uvnitr funkce
			// na velikost 10B.
    
    delete [] pChar; // dynamicky alokovanou pamet musime uvolnit!!!

    int d;
    int *i = (int *) memoryAllock(); // i ukazuje na alokovanou pamet o velikosti 10B.
    i = &d;	// memory leak!!! Jediny exemplar adresy na alokovanou pamet jsme
		// prave ztratili!!!
    

    // Dynamicka alokace 3D pole, verze pro C: 

    int ***pole3D; // ukazatel na ukazatel na ukazatel na typ integer

    // Alokace pameti pro trojrozmerne pole
    pole3D = (int ***) malloc(sizeof(int **) * 3);
    for(int i = 0; i < 3; ++i){
		pole3D[i] = (int **) malloc(sizeof(int *) * 3);
		for(int j = 0; j < 3; ++j){
			pole3D[i][j] = (int *) malloc(sizeof(int) * 3);
		}
    }    

    // Dealokace pameti
    for(int i = 0; i < 3; i++){
		for(int j = 0; j < 3; j++){
			free(pole3D[i][j]);
		}
		free(pole3D[i]);
		}
    free(pole3D);


    // Dynamicka alokace 3D pole, verze pro C++:

    pole3D = new int**[3];
    for(int i = 0; i < 3; ++i){
		pole3D[i] = new int *[3];
		for(int j = 0; j < 3; ++j){
			pole3D[i][j] = new int[3	];
		}
	}
    
    for(int i = 0; i < 3; i++){
		for(int j = 0; j < 3; j++){
			delete [] pole3D[i][j];
		}
		delete [] pole3D[i];
		}
	delete [] pole3D;


	// Pointerova aritmetika
	int array[20];
	int *pArray1 = array;
	int *pArray2 = NULL;

	// Naplneni pole array hodnotami pomoci pointerove aritmetiky
	for(int i = 0; i < 20; ++i){
		*(pArray1 + i) = i;
		// nebo:
		// *pArray = i;
		// pArray ++;
	}
	// Vypsani pole array pomoci pointerove aritmetiky
	pArray1 = array;
	while(pArray1 < array + 20){
		// Inkrementace ukazetele zvetsi jeho hodnotu ne o pocet
		// bytu, ale o velikost jeho datoveho typu!
		cout << *(pArray1++) << endl;
	}
	// Pomoci dvou ukazatelu do stejneho pole muzeme vypocitat,
	// kolik prvku mezi temito ukazateli lezi.
	pArray1 = array;
	// Ukazatel pArray2 ukazauje na prvni byte za konec pole array
	pArray2 = &array[20];
	// Ted si muzeme na standardni vystup vypsat velikost pole array
	// pomoci pointerove aritmetiky
	cout << "Velikost pole array: " << pArray2 - pArray1 << endl;
	// Predchozi radek nevypise pocet bytu mezi ukazateli, ale pocet
	// bytu mezi nimi / sizeof(int)


    return 0;
}
